package com.loganmagnan.blockhealth.menus;

import com.loganmagnan.blockhealth.utils.menusystem.ItemStackButton;
import com.loganmagnan.blockhealth.utils.menusystem.PaginatedMenu;
import com.loganmagnan.blockhealth.BlockHealth;
import com.loganmagnan.blockhealth.utils.Utils;
import com.loganmagnan.blockhealth.utils.menusystem.PlayerMenuUtil;
import net.wesjd.anvilgui.AnvilGUI;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.ItemStack;

import java.util.ArrayList;
import java.util.List;

public class BlockHealthsMenu extends PaginatedMenu {

    private BlockHealth main = BlockHealth.getInstance();

    public BlockHealthsMenu(PlayerMenuUtil playerMenuUtil) {
        super(playerMenuUtil);
    }

    @Override
    public String getMenuName() {
        return Utils.translate("&eBlock healths");
    }

    @Override
    public int getSlots() {
        return 54;
    }

    @Override
    public void handleMenu(InventoryClickEvent event) {
        Player player = (Player) event.getWhoClicked();

        if (event.getView().getTitle().equalsIgnoreCase(Utils.translate("&eBlock healths"))) {
            ItemStack itemStack = event.getCurrentItem();

            for (Material material : this.main.getBlockManager().getBlockHealths().keySet()) {
                if (itemStack.getType() != material) {
                    continue;
                }

                new AnvilGUI.Builder().onComplete((anvilGUIPlayer, string) -> {
                    int blockHealth = Integer.parseInt(string);

                    this.main.getBlockManager().getBlockHealths().get(material).set(blockHealth);
                    this.main.getMainConfig().getConfig().set("BLOCKS." + material.name() + ".HEALTH", blockHealth);
                    this.main.getMainConfig().save();

                    return AnvilGUI.Response.close();
                }).onClose(anvilGUIPlayer -> {

                }).title(Utils.translate("&eChange " + material.name() + " health")).text("").plugin(this.main).open(player);
            }

            switch (ChatColor.stripColor(event.getCurrentItem().getItemMeta().getDisplayName())) {
                case "Previous page":
                    if (this.page == 0) {
                        player.sendMessage(Utils.translate("&aYou are on the first page"));
                    } else {
                        this.page--;
                        this.open(player);
                    }

                    break;
                case "Close":
                    player.closeInventory();

                    break;
                case "Next page":
                    if (!((this.index++) >= this.main.getBlockManager().getBlockHealths().size())) {
                        this.page++;
                        this.open(player);
                    } else {
                        player.sendMessage(Utils.translate("&aYou are on the last page"));
                    }

                    break;
            }
        }
    }

    @Override
    public void setMenuItems(Player player) {
        this.addMenuBorder();
        this.main.getBlockManager().getBlockHealths().forEach((material, atomicInteger) -> {
            List<String> lore = new ArrayList<String>();
            lore.add(Utils.translate("&bBlock health: &f" + atomicInteger.get()));
            lore.add(Utils.translate(""));
            lore.add(Utils.translate("&7Click to change"));

            ItemStackButton itemStackButton = new ItemStackButton(
                    Utils.translate("&b" + material.name()),
                    lore,
                    material,
                    0,
                    1
            );

            ItemStack itemStack = itemStackButton.makeItemStack();

            this.inventory.addItem(itemStack);
        });
    }
}
